package org.pigeonblood.test;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.transform.sax.SAXSource;

import org.lixm.core.common.LIXMException;
import org.lixm.core.common.LIXMPhaseException;
import org.lixm.core.common.XMLType;
import org.lixm.core.list.AttributesList;
import org.lixm.core.model.AbstractModel;
import org.lixm.core.model.AttributeModel;
import org.lixm.core.model.StartTagModel;
import org.lixm.optional.v15.atattch.XMLReceiver;
import org.lixm.optional.v16.framework.rpf.pipeline.push.PushPipeLine;
import org.pigeonblood.impl.core.list.SimpleDocumentList;
import org.pigeonblood.impl.core.modelizer.PushXMLModelizer;
import org.pigeonblood.impl.core.modelizer.PushXMLModelizer.DefaultModelizeResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

/**
 * pCvCƑXg̃eXg
 * @author tasogare
 *
 */
public class Test3 {

	PushXMLModelizer modelizer;
	SimpleDocumentList list;
	File xmlFile;
	SAXSource xmlSource; 

	/**
	 * @param args
	 */
	public static void main(
	    String[] args)
	{
		Test3 test = new Test3(args);
		try {
	        test.modelizer.modelize( );
        } catch ( LIXMPhaseException e ) {
	        e.printStackTrace();
	        System.exit(1);
        }

        PushPipeLine<AbstractModel> pipeLine =
        	new PushPipeLine<AbstractModel>(test.list, newReceiver());

        try {
	        pipeLine.push( );
        } catch ( LIXMException e ) {
	        e.printStackTrace();
	        System.exit(1);
        }
	}

	public Test3(String[] args){
		xmlFile = analizeArgs(args);

		createXMLSource();
		createXMLDocumentList();
		createXMLModelizer();
	}

	private final File analizeArgs(String[] args){

		if(args.length != 1){
			usage();
			System.exit(1);
		}

		return new File(args[0]);
	}

	private final void createXMLSource(){
		try {
	        xmlSource = new SAXSource(new InputSource(new FileReader(xmlFile)));
        } catch ( FileNotFoundException e ) {
	        throw new AssertionError("xmlt@C܂B");
        }
	}

	private final void createXMLModelizer(){

		if(xmlSource == null){
			throw new AssertionError("XML\[X܂B");
		}

		if(list == null){
			throw new AssertionError("Xg܂B");
		}

		modelizer = (PushXMLModelizer) PushXMLModelizer.newInstance(xmlSource, list);

		SAXParserFactory xrf = SAXParserFactory.newInstance( );
		xrf.setNamespaceAware(true);

		try {
	        SAXParser r = xrf.newSAXParser( );

	        DefaultModelizeResolver resolver = modelizer.new DefaultModelizeResolver( );

	        r.setProperty("http://xml.org/sax/properties/lexical-handler", resolver);

	        r.getXMLReader( ).setContentHandler(resolver);
	        xmlSource.setXMLReader(r.getXMLReader( ));

		} catch ( ParserConfigurationException e ) {
	        e.printStackTrace();
	        System.exit(1);
        } catch ( SAXException e ) {
	        e.printStackTrace();
	        System.exit(1);
        }
	}

	private final void createXMLDocumentList(){
		list = new SimpleDocumentList(100);
	}

	public static XMLReceiver newReceiver(){
		XMLReceiver receiver = new XMLReceiver(){

			public void receive(
                AbstractModel model) throws LIXMException
            {
				if(model.matchTypes(XMLType.START_TAG)){

					StartTagModel startTag = (StartTagModel)model;
					System.out.println(startTag.getName( ) + "vf̑");

					AttributesList atts = startTag.getAttributes( );
					if(atts.size( ) == 0){
						System.out.println("\tȂ");
					}

					
					for(AttributeModel att : atts){
						System.out.println("\t" + att);
					}
					System.out.println();
				}
            }
			
		};
		return receiver;
	}

	private final void usage() {
        System.out.println("Usage:");
        System.out.println("\t\tjava Test3 input_xml_file");
    }

}
